$(document).on('turbolinks:load', function() {
  if ($('body.admins-user-schools-statistics-index-page').length > 0) {
    var $form = $('.user-schools-statistic-list-form');

    // ************** 学校选择 *************
    var matcherFunc = function(params, data){
      if ($.trim(params.term) === '') {
        return data;
      }
      if (typeof data.text === 'undefined') {
        return null;
      }

      if (data.name && data.name.indexOf(params.term) > -1) {
        var modifiedData = $.extend({}, data, true);
        return modifiedData;
      }

      // Return `null` if the term should not be displayed
      return null;
    }


    var defineSchoolSelect = function (schools) {
      $form.find('.school-select').select2({
        theme: 'bootstrap4',
        placeholder: '选择学校/单位',
        minimumInputLength: 1,
        data: schools,
        templateResult: function (item) {
          if(!item.id || item.id === '') return item.text;
          return item.name;
        },
        templateSelection: function(item){
          if (item.id) {
            $form.find('#school_id').val(item.id);
          }
          return item.name || item.text;
        },
        matcher: matcherFunc
      });
    };


    // 初始化学校选择器
    $.ajax({
      url: '/api/schools/for_option.json',
      dataType: 'json',
      type: 'GET',
      success: function(data) {
        defineSchoolSelect(data.schools);
      }
    });

    // 清空
    $form.on('click', '.clear-btn', function(){
      $form.find('select[name="date"]').val('');
      $form.find('select[name="province"]').val('');
      $form.find('.school-select').val('').trigger('change');
      $form.find('input[type="submit"]').trigger('click');
    })


    // 导出
    $('.export-action').on('click', function(){
      var form = $(".user-schools-statistic-list-form")
      var exportLink = $(this);
      var date = form.find("select[name='date']").val();
      var schoolId = form.find('input[name="school_id"]').val();
      var province = form.find('input[name="province"]').val();
      console.log(province)
      if(province == "" || province == null){
          alert("只能按省份导出");
          return;
      }

      var url = exportLink.data("url").split('?')[0] + "?date=" + date + "&school_id=" + schoolId + "&province=" + province;
      window.open(url);
    });
  }
});